﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var BaseBankGuarantees = (function (_super) {
    __extends(BaseBankGuarantees, _super);
    function BaseBankGuarantees(id, document) {
        var _this = _super.call(this, id) || this;
        _this._bankKey = null;
        _this._okv = null;
        _this._providerType = null;
        _this._secType = null;
        _this._tofkKey = null;
        _this._tofkMinfinKey = null;
        _this._customerKey = null;
        _this._legalEntityProvider = null;
        _this._individualProvider = null;
        _this._foreignCitizenProvider = null;
        _this._foreignLegalProvider = null;
        _this._status = null;
        _this._ftEmployee = null;
        _this._statementEmployee = null;
        _this._bankEmployee = null;
        _this._document = document;
        _this._rowNumber = new NumberObasTableField("RowNumber", _this);
        _this._code = new ObasTableField("Code", _this);
        _this._usdValue = new NumberObasTableField("UsdValue", _this);
        _this._createDate = new ObasTableField("CreateDate", _this);
        _this._issueDate = new ObasTableField("IssueDate", _this);
        _this._statementDate = new ObasTableField("StatementDate", _this);
        _this._statementNum = new ObasTableField("StatementNum", _this);
        _this._ftRegNum = new ObasTableField("FTRegNum", _this);
        _this._ftReceivedDate = new ObasTableField("FTReceivedDate", _this);
        _this._regCode = new ObasTableField("RegCode", _this);
        _this._isUserTofk = new ObasTableField("TOFKType", _this);
        _this._providerName = new ObasTableField("ProviderName", _this);
        _this._tofkName = new ObasTableField("TOFKName", _this);
        _this._purchase = new ObasTableField("PurchaseCode", _this);
        _this._ftMessageId = new ObasTableField("Id", _this);
        _this._ftMessageVer = new NumberObasTableField("FTMessageVer", _this);
        _this._ftMessageCanExport = new ObasTableField("FTMessageCanExport", _this);
        _this._isArchField = new ObasTableField("IsArchived", _this);
        _this._archReason = new ObasTableField("ArchivedReason", _this);
        return _this;
    }
    Object.defineProperty(BaseBankGuarantees.prototype, "InitCreateDate", {
        get: function () {
            var date = new Date();
            date.setMilliseconds(0);
            return date;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "ProviderTypeField", {
        get: function () {
            if (this._providerType == null) {
                this._providerType = new ObasSprTableField(TableCollection.ProviderTypesSprTable, this);
            }
            return this._providerType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "CreateDateField", {
        get: function () {
            return this._createDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "ProviderTable", {
        get: function () {
            switch (this.ProviderType) {
                case ProviderTypes.LegalEntity:
                    return this.LegalEntityProvider.SourceTable;
                case ProviderTypes.IndividualBusinessman:
                    return this.IndividualProvider.SourceTable;
                case ProviderTypes.ForeignCitizen:
                    return this.ForeignCitizenProvider.SourceTable;
                case ProviderTypes.ForeignLegalEntity:
                    return this.ForeignLegalProvider.SourceTable;
            }
            return null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "IsDraft", {
        get: function () {
            return this.StatusField.ForeignKey.Value === ObasHelper.DraftStatusKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "IsArched", {
        get: function () {
            return this._isArchField.Value;
        },
        set: function (value) {
            this._isArchField.Value = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "ArchedReason", {
        get: function () {
            return this._archReason;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "PurchaseCode", {
        get: function () {
            return this._purchase;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "StatusField", {
        get: function () {
            if (this._status == null) {
                this._status = this.InitStatusField();
            }
            return this._status;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "FtEmployee", {
        get: function () {
            if (this._ftEmployee == null) {
                this._ftEmployee = new EmployeeFields(this, "FT");
            }
            return this._ftEmployee;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "StatementEmployee", {
        get: function () {
            if (this._statementEmployee == null) {
                this._statementEmployee = new EmployeeFields(this, "Statement");
            }
            return this._statementEmployee;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "BankEmployee", {
        get: function () {
            if (this._bankEmployee == null) {
                this._bankEmployee = new EmployeeFields(this, "Bank");
            }
            return this._bankEmployee;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "RowNumber", {
        get: function () {
            return this._rowNumber;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "FtMessageId", {
        get: function () {
            return this._ftMessageId;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "FtMessageVerField", {
        get: function () {
            return this._ftMessageVer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "FtMessageVer", {
        get: function () {
            return this.FtMessageCanExport.Value ? this._ftMessageVer.Value : this._ftMessageVer.Value - 1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "ProviderType", {
        get: function () {
            return this.ProviderTypeField.ForeignKey.Value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "SecurityType", {
        get: function () {
            if (this._secType == null) {
                this._secType = new ObasSprTableField(TableCollection.SecurityTypesSprTable, this);
            }
            return this._secType;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "TofkTable", {
        get: function () {
            if (this.IsUserTofk.Value) {
                return this.TofkKey.SourceTable;
            }
            else {
                return this.TofkMinfinKey.SourceTable;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "TofkKey", {
        get: function () {
            if (this._tofkKey == null) {
                this._tofkKey = new TofkKeyTableField(TableCollection.TofkTable, this);
            }
            return this._tofkKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "BankKey", {
        get: function () {
            if (this._bankKey == null) {
                this._bankKey = new VersionElementForeignKeyTableField(TableCollection.BankTable, this);
            }
            return this._bankKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "TofkMinfinKey", {
        get: function () {
            if (this._tofkMinfinKey == null) {
                this._tofkMinfinKey = new TofkKeyTableField(TableCollection.TofkMinfinTable, this);
            }
            return this._tofkMinfinKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "LegalEntityProvider", {
        get: function () {
            if (this._legalEntityProvider == null) {
                this._legalEntityProvider = this.InitLegalEntity();
            }
            return this._legalEntityProvider;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "IndividualProvider", {
        get: function () {
            if (this._individualProvider == null) {
                this._individualProvider = this.InitIndividual();
            }
            return this._individualProvider;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "ForeignCitizenProvider", {
        get: function () {
            if (this._foreignCitizenProvider == null) {
                this._foreignCitizenProvider = this.InitForeignCitizeny();
            }
            return this._foreignCitizenProvider;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "ForeignLegalProvider", {
        get: function () {
            if (this._foreignLegalProvider == null) {
                this._foreignLegalProvider = this.InitForeignLegal();
            }
            return this._foreignLegalProvider;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "CustomerKey", {
        get: function () {
            if (this._customerKey == null) {
                this._customerKey = this.InitCustomer();
            }
            return this._customerKey;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "TemplateCreateDate", {
        get: function () {
            return "№" + this.RecordKey.Value + " " + ObasHelper.GetLongDate();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "CreateDate", {
        get: function () {
            return this._createDate.Value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "Code", {
        get: function () {
            return this._code;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "IsUserTofk", {
        get: function () {
            return this._isUserTofk;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "IssueDate", {
        get: function () {
            return this._issueDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "RegistryCode", {
        get: function () {
            return this._regCode;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "Okv", {
        get: function () {
            if (this._okv == null) {
                this._okv = new ObasSprTableField(TableCollection.OkvSprTable, this);
            }
            return this._okv;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "UsdValue", {
        get: function () {
            return this._usdValue;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "StatementDate", {
        get: function () {
            return this._statementDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "StatementNum", {
        get: function () {
            return this._statementNum;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "FtRegNum", {
        get: function () {
            return this._ftRegNum;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "FtReceivedDate", {
        get: function () {
            return this._ftReceivedDate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "FtMessageCanExport", {
        get: function () {
            return this._ftMessageCanExport;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "OrgProvider", {
        get: function () {
            throw new Error("OrgProvider must be implemented in child");
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BaseBankGuarantees.prototype, "ForeignProvider", {
        get: function () {
            throw new Error("ForeignProvider must be implemented in child");
        },
        enumerable: true,
        configurable: true
    });
    BaseBankGuarantees.prototype.GenerateNode = function (nodeId, isRequired, maxOccurs) {
        var node = _super.prototype.GenerateNode.call(this, nodeId, isRequired, maxOccurs);
        node.IsRequired = true;
        node.MaxOccurs = null;
        return node;
    };
    BaseBankGuarantees.prototype.CreateCopy = function (sourceKey) {
        if (this.LocateByKeys(sourceKey)) {
            this.CloneRow();
            if (this.RecordKey.Value !== sourceKey) {
                this.IsArched = false;
                this.StatusField.ForeignKey.Value = ObasHelper.DraftStatusKey;
                this.RowNumber.Value = TableCollection.SequenceTable.GetCurrentKey(this);
                this.FtReceivedDate.Value = null;
                this.FtRegNum.Value = null;
                this.FtEmployee.RecordKey.Value = null;
                this.StatementNum.Value = null;
                this.StatementDate.Value = null;
                this.StatementEmployee.RecordKey.Value = null;
                this.ArchedReason.Value = null;
                this.DoAfterCopy(sourceKey);
            }
        }
    };
    BaseBankGuarantees.prototype.CalcProviderFullName = function () {
        var provider = this.ProviderTable;
        if (provider != null) {
            return provider.GetFullName();
        }
        return "";
    };
    BaseBankGuarantees.prototype.GetExportNameParts = function () {
        var fileNameParts = _super.prototype.GetExportNameParts.call(this);
        if (this.RowCount > 0) {
            fileNameParts.splice(1, 0, this.RowNumber.Value.toString(), this.FtMessageVer.toString());
        }
        return fileNameParts;
    };
    BaseBankGuarantees.prototype.ExportToExcel = function (recordKey) {
        if (this.LocateByKeys(recordKey)) {
            var template = this.GetXlsTemplate();
            var fileNameParts = this.GetExportNameParts();
            fileNameParts[0] = template.FileName;
            this._document.ExportToExcel("xls\\" + template.TemplateName, fileNameParts.join("_"), false, false, ObasHelper.GetExcelExportFolder());
        }
    };
    BaseBankGuarantees.prototype.CreateDateInitEventHandler = function (tableId) {
        return this.InitCreateDate.toJSON();
    };
    BaseBankGuarantees.prototype.CalcTOFKFullName = function () {
        var source = this.TofkTable;
        return (source ? source.OrgFields.FullName.Value : "");
    };
    BaseBankGuarantees.prototype.CalcProviderKpp = function () {
        var providerTable = this.OrgProvider;
        if (providerTable != null) {
            return providerTable.OrgFields.Kpp.toString();
        }
        else {
            return "";
        }
    };
    BaseBankGuarantees.prototype.CalcForeignInn = function () {
        var providerTable = this.ForeignProvider;
        if (providerTable != null) {
            return providerTable.ForeignData.Inn.toString();
        }
        else {
            return "";
        }
    };
    BaseBankGuarantees.prototype.GetMinDate = function () {
        var reader = this.CreateReader();
        var result = null;
        while (reader.Read()) {
            var tmpDate = this.CreateDate;
            if (result == null || (tmpDate && +tmpDate < +result)) {
                result = tmpDate;
            }
        }
        return result;
    };
    BaseBankGuarantees.prototype.ProviderSprTableEdited = function (fieldId, key) {
        while (this.Locate(fieldId, key, true)) {
            this.ProviderNameChangeEventHandler(null, null, null, null);
        }
        this.ClearLocateFlag();
    };
    BaseBankGuarantees.prototype.ProviderNameChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        this.FtFieldsChangeEventHandler(tableId, oldValue, newValue, fieldId);
        this._providerName.Value = this.CalcProviderFullName();
    };
    BaseBankGuarantees.prototype.TofkNameChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        if (this instanceof BankGuaranteesRequestTable) {
            this.FtFieldsChangeEventHandler(tableId, oldValue, newValue, fieldId);
        }
        this._tofkName.Value = this.CalcTOFKFullName();
    };
    BaseBankGuarantees.prototype.BankDetailsInitEventHandler = function (tableId, fieldId) {
        var banksSpr = TableCollection.BankTable;
        if (this._document.AssemblyType === AssemblyTypes.Full &&
            banksSpr.RowCount > 0 &&
            banksSpr.Locate(banksSpr.EndDate.Id, undefined)) {
            return banksSpr.RecordKey.Value;
        }
        return undefined;
    };
    BaseBankGuarantees.prototype.DateCheckEventHandler = function (dateField1, dateField2, ignoreTime) {
        if (ignoreTime === void 0) { ignoreTime = false; }
        var date1 = dateField1.Value;
        var date2 = dateField2.Value;
        if (ignoreTime) {
            ObasHelper.NullifyTime(date1);
            ObasHelper.NullifyTime(date2);
        }
        if (date1 != null &&
            date2 != null &&
            +date1 < +date2) {
            return "Значение поля «" + dateField1.Caption + "» не может быть меньше значения поля «" + dateField2.Caption + "»";
        }
        else {
            return undefined;
        }
    };
    BaseBankGuarantees.prototype.DateEqualsCheckEventHandler = function (dateField1, dateField2, ignoreTime) {
        if (ignoreTime === void 0) { ignoreTime = false; }
        var date1 = dateField1.Value;
        var date2 = dateField2.Value;
        if (ignoreTime) {
            ObasHelper.NullifyTime(date1);
            ObasHelper.NullifyTime(date2);
        }
        if (+(date1 || 0) !== +(date2 || 0)) {
            return "Значение поля «" + dateField1.Caption + "» должно равняться значению поля «" + dateField2.Caption + "»";
        }
        else {
            return undefined;
        }
    };
    BaseBankGuarantees.prototype.FTReceivedDateCheckEventHandler = function (tableId, fieldId) {
        return this.DateCheckEventHandler(this.FtReceivedDate, this.CreateDateField);
    };
    BaseBankGuarantees.prototype.StatementDateCheckEventHandler = function (tableId, fieldId) {
        return this.DateCheckEventHandler(this.StatementDate, this.FtReceivedDate, true);
    };
    BaseBankGuarantees.prototype.IssueDateCheckEventHandler = function (tableId, fieldId) {
        return this.DateCheckEventHandler(this.CreateDateField, this.IssueDate);
    };
    BaseBankGuarantees.prototype.RowNumberInitEventHandler = function (tableId) {
        return TableCollection.SequenceTable.GetNextKey(this);
    };
    BaseBankGuarantees.prototype.FtFieldsChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        this.FtMessageCanExport.Value = true;
    };
    BaseBankGuarantees.prototype.LegalEntitySprTableEdited = function (key) {
        this.ProviderSprTableEdited(this.LegalEntityProvider.Id, key);
    };
    BaseBankGuarantees.prototype.IndividualSprTableEdited = function (key) {
        this.ProviderSprTableEdited(this.IndividualProvider.Id, key);
    };
    BaseBankGuarantees.prototype.ForeignCitizenSprTableEdited = function (key) {
        this.ProviderSprTableEdited(this.ForeignCitizenProvider.Id, key);
    };
    BaseBankGuarantees.prototype.ForeignLegalEntitySprTableEdited = function (key) {
        this.ProviderSprTableEdited(this.ForeignLegalProvider.Id, key);
    };
    BaseBankGuarantees.prototype.FtSprTableEdited = function (fieldId, key) {
        while (this.Locate(fieldId, key, true)) {
            this.FtFieldsChangeEventHandler(null, null, null, null);
        }
        this.ClearLocateFlag();
    };
    BaseBankGuarantees.prototype.FtMessageVersionInitEventHandler = function (tableId) {
        return 1;
    };
    BaseBankGuarantees.prototype.CalcTextSecrecy = function () {
        var _SecurityTypeName = this.SecurityType.Name;
        return TableCollection.PrintOptionsSprTable.TextSecrecy(_SecurityTypeName);
    };
    BaseBankGuarantees.prototype.PrintOptionsSprTableChangeEventHandler = function (tableId, oldValue, newValue, fieldId) {
        var _PrintOptions = new ObasSprTableField(TableCollection.PrintOptionsSprTable, this);
        return _PrintOptions.IsPrintSecrecyChangeEventHandler(tableId, oldValue, newValue, fieldId);
    };
    return BaseBankGuarantees;
}(BaseEntityTable));
