﻿var FillCharactersDirection;
(function (FillCharactersDirection) {
    FillCharactersDirection[FillCharactersDirection["First"] = 1] = "First";
    FillCharactersDirection[FillCharactersDirection["Last"] = 2] = "Last";
})(FillCharactersDirection || (FillCharactersDirection = {}));
var EditorShowMode;
(function (EditorShowMode) {
    EditorShowMode[EditorShowMode["Undefined"] = -1] = "Undefined";
    EditorShowMode[EditorShowMode["Create"] = 0] = "Create";
    EditorShowMode[EditorShowMode["Edit"] = 1] = "Edit";
    EditorShowMode[EditorShowMode["Preview"] = 2] = "Preview";
})(EditorShowMode || (EditorShowMode = {}));
var AssemblyTypes;
(function (AssemblyTypes) {
    AssemblyTypes[AssemblyTypes["Full"] = 1] = "Full";
    AssemblyTypes[AssemblyTypes["OnlyRequest"] = 2] = "OnlyRequest";
})(AssemblyTypes || (AssemblyTypes = {}));
var DocumentTypes;
(function (DocumentTypes) {
    DocumentTypes[DocumentTypes["Original"] = 1] = "Original";
    DocumentTypes[DocumentTypes["Copy"] = 2] = "Copy";
    DocumentTypes[DocumentTypes["Proxy"] = 3] = "Proxy";
})(DocumentTypes || (DocumentTypes = {}));
var DataStatuses;
(function (DataStatuses) {
    DataStatuses[DataStatuses["Draft"] = ObasHelper.DraftStatusKey] = "Draft";
    DataStatuses[DataStatuses["Send"] = 3] = "Send";
    DataStatuses[DataStatuses["Received"] = 4] = "Received";
    DataStatuses[DataStatuses["Included"] = 5] = "Included";
    DataStatuses[DataStatuses["Denied"] = 6] = "Denied";
    DataStatuses[DataStatuses["Ready"] = ObasHelper.ReadyStatusKey] = "Ready";
})(DataStatuses || (DataStatuses = {}));
var RequestStatuses;
(function (RequestStatuses) {
    RequestStatuses[RequestStatuses["Draft"] = ObasHelper.DraftStatusKey] = "Draft";
    RequestStatuses[RequestStatuses["Send"] = 3] = "Send";
    RequestStatuses[RequestStatuses["Received"] = 4] = "Received";
    RequestStatuses[RequestStatuses["Ready"] = ObasHelper.ReadyStatusKey] = "Ready";
})(RequestStatuses || (RequestStatuses = {}));
var ProviderTypes;
(function (ProviderTypes) {
    ProviderTypes[ProviderTypes["LegalEntity"] = 1] = "LegalEntity";
    ProviderTypes[ProviderTypes["IndividualBusinessman"] = 2] = "IndividualBusinessman";
    ProviderTypes[ProviderTypes["ForeignCitizen"] = 3] = "ForeignCitizen";
    ProviderTypes[ProviderTypes["ForeignLegalEntity"] = 4] = "ForeignLegalEntity";
})(ProviderTypes || (ProviderTypes = {}));
var StatementTypes;
(function (StatementTypes) {
    StatementTypes[StatementTypes["Full"] = 1] = "Full";
    StatementTypes[StatementTypes["Light"] = 2] = "Light";
})(StatementTypes || (StatementTypes = {}));
var MethodTypes;
(function (MethodTypes) {
    MethodTypes[MethodTypes["TerrAuthority"] = 1] = "TerrAuthority";
    MethodTypes[MethodTypes["Site"] = 2] = "Site";
    MethodTypes[MethodTypes["RequestAddress"] = 3] = "RequestAddress";
})(MethodTypes || (MethodTypes = {}));
var SecurityTypes;
(function (SecurityTypes) {
    SecurityTypes[SecurityTypes["Confidential"] = 3] = "Confidential";
    SecurityTypes[SecurityTypes["Secret"] = 1] = "Secret";
    SecurityTypes[SecurityTypes["TopSecret"] = 2] = "TopSecret";
    SecurityTypes[SecurityTypes["Unclassified"] = 4] = "Unclassified";
})(SecurityTypes || (SecurityTypes = {}));
var DateFormat;
(function (DateFormat) {
    DateFormat[DateFormat["Long"] = 1] = "Long";
    DateFormat[DateFormat["Middle"] = 2] = "Middle";
    DateFormat[DateFormat["Short"] = 3] = "Short";
    DateFormat[DateFormat["Json"] = 4] = "Json";
    DateFormat[DateFormat["OnlyTime"] = 5] = "OnlyTime";
})(DateFormat || (DateFormat = {}));
var NodeTypeTypes;
(function (NodeTypeTypes) {
    NodeTypeTypes[NodeTypeTypes["Complex"] = 0] = "Complex";
    NodeTypeTypes[NodeTypeTypes["Base"] = 1] = "Base";
    NodeTypeTypes[NodeTypeTypes["Simple"] = 2] = "Simple";
    NodeTypeTypes[NodeTypeTypes["Choice"] = 3] = "Choice";
})(NodeTypeTypes || (NodeTypeTypes = {}));
