﻿var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var SimpleElementContainer = (function () {
    function SimpleElementContainer(table, document) {
        this._editor = null;
        this._document = document;
        this._table = table;
    }
    Object.defineProperty(SimpleElementContainer.prototype, "Table", {
        get: function () {
            return this._table;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SimpleElementContainer.prototype, "Document", {
        get: function () {
            return this._document;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SimpleElementContainer.prototype, "Editor", {
        get: function () {
            if (this._editor == null) {
                this._editor = new SprElementEditor(this._table, this._document);
            }
            return this._editor;
        },
        enumerable: true,
        configurable: true
    });
    return SimpleElementContainer;
}());
var TofkMinfinContainer = (function (_super) {
    __extends(TofkMinfinContainer, _super);
    function TofkMinfinContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._editor = null;
        return _this;
    }
    Object.defineProperty(TofkMinfinContainer.prototype, "Editor", {
        get: function () {
            if (this._editor == null) {
                this._editor = new TofkMinfinEditor(this.Table, this.Document);
            }
            return this._editor;
        },
        enumerable: true,
        configurable: true
    });
    return TofkMinfinContainer;
}(SimpleElementContainer));
var ElementContainer = (function (_super) {
    __extends(ElementContainer, _super);
    function ElementContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._listEditor = null;
        return _this;
    }
    Object.defineProperty(ElementContainer.prototype, "ListEditor", {
        get: function () {
            if (this._listEditor == null) {
                this._listEditor = new SprElementsListEditor(this.Editor, this.Document);
            }
            return this._listEditor;
        },
        enumerable: true,
        configurable: true
    });
    return ElementContainer;
}(SimpleElementContainer));
var VersionElementContainer = (function (_super) {
    __extends(VersionElementContainer, _super);
    function VersionElementContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._listEditor = null;
        _this._editor = null;
        return _this;
    }
    Object.defineProperty(VersionElementContainer.prototype, "Editor", {
        get: function () {
            if (this._editor == null) {
                this._editor = new VersionElementEditor(this.Table, this.Document);
            }
            return this._editor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VersionElementContainer.prototype, "ListEditor", {
        get: function () {
            if (this._listEditor == null) {
                this._listEditor = new SprVersionElementsListEditor(this.Editor, this.Document);
            }
            return this._listEditor;
        },
        enumerable: true,
        configurable: true
    });
    return VersionElementContainer;
}(ElementContainer));
