﻿var TableChangeEvent = (function () {
    function TableChangeEvent() {
        this._handlers = [];
    }
    TableChangeEvent.prototype.Add = function (handler) {
        if (this._handlers.indexOf(handler) === -1) {
            this._handlers.push(handler);
        }
    };
    TableChangeEvent.prototype.Remove = function (handler) {
        var index = this._handlers.indexOf(handler);
        if (index > -1) {
            this._handlers.splice(index, 1);
        }
    };
    TableChangeEvent.prototype.Do = function (key) {
        for (var i = 0, len = this._handlers.length; i < len; i++) {
            this._handlers[i](key);
        }
    };
    return TableChangeEvent;
}());
