﻿var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var DocumentFMain = (function (_super) {
    __extends(DocumentFMain, _super);
    function DocumentFMain(id, version, oldVersion) {
        var _this = _super.call(this, id, version, oldVersion) || this;
        _this._bankGuaranteesTable = null;
        _this._bankGuaranteesRequestTable = null;
        _this._legalEntityContainer = null;
        _this._individualBusinessmanContainer = null;
        _this._foreignCitizenContainer = null;
        _this._foreignLegalContainer = null;
        _this._customerContainer = null;
        _this._declarerContainer = null;
        _this._tofkContainer = null;
        _this._bankContainer = null;
        _this._bankShortContainer = null;
        _this._legalEntityShortContainer = null;
        _this._individualBusinessmanShortContainer = null;
        _this._foreignCitizenShortContainer = null;
        _this._foreignLegalShortContainer = null;
        _this._customerShortContainer = null;
        _this._tofkMinfinContainer = null;
        _this._infoEditor = null;
        _this._requestEditor = null;
        _this._printOptionsTable = null;
        _this._interfaceRules = new InterfaceRulesFMain(_this);
        _this._updateRules = new UpdateRulesFMain(_this);
        return _this;
    }
    Object.defineProperty(DocumentFMain.prototype, "AssemblyType", {
        get: function () {
            var paramTable = this.Tables.getValue("WorkParams");
            return paramTable ? paramTable.GetFieldValue("AssemblyType") : null;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "InterfaceRules", {
        get: function () {
            return this._interfaceRules;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "UpdateRules", {
        get: function () {
            return this._updateRules;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "InfoSheet", {
        get: function () {
            if (this._infoSheet == null) {
                this._infoSheet = new InfoRegisrtySheet("InfoReg", this.InfoEditor);
            }
            return this._infoSheet;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "RequestSheet", {
        get: function () {
            if (this._requestSheet == null) {
                this._requestSheet = new RegisrtySheet("RequestReg", this.RequestEditor);
            }
            return this._requestSheet;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "ArchInfoSheet", {
        get: function () {
            if (this._archInfoSheet == null) {
                this._archInfoSheet = new ArchRegisrtySheet("ArchInfoReg", this.InfoEditor);
            }
            return this._archInfoSheet;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "ArchRequestSheet", {
        get: function () {
            if (this._archRequestSheet == null) {
                this._archRequestSheet = new ArchRegisrtySheet("ArchRequestReg", this.RequestEditor);
            }
            return this._archRequestSheet;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "BankGuaranteesTable", {
        get: function () {
            if (this._bankGuaranteesTable == null) {
                this._bankGuaranteesTable = new BankGuaranteesTable(this);
            }
            return this._bankGuaranteesTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "BankGuaranteesRequestTable", {
        get: function () {
            if (this._bankGuaranteesRequestTable == null) {
                this._bankGuaranteesRequestTable = new BankGuaranteesRequestTable(this);
            }
            return this._bankGuaranteesRequestTable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "BankContainer", {
        get: function () {
            if (this._bankContainer == null) {
                this._bankContainer = new VersionElementContainer(TableCollection.BankTable, this);
            }
            return this._bankContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "LegalEntityContainer", {
        get: function () {
            if (this._legalEntityContainer == null) {
                this._legalEntityContainer = new VersionElementContainer(TableCollection.LegalEntityProviderTable, this);
            }
            return this._legalEntityContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "IndividualBusinessmanContainer", {
        get: function () {
            if (this._individualBusinessmanContainer == null) {
                this._individualBusinessmanContainer = new VersionElementContainer(TableCollection.IndividualBusinessmanTable, this);
            }
            return this._individualBusinessmanContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "ForeignCitizenContainer", {
        get: function () {
            if (this._foreignCitizenContainer == null) {
                this._foreignCitizenContainer = new VersionElementContainer(TableCollection.ForeignCitizenTable, this);
            }
            return this._foreignCitizenContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "ForeignLegalContainer", {
        get: function () {
            if (this._foreignLegalContainer == null) {
                this._foreignLegalContainer = new VersionElementContainer(TableCollection.ForeignLegalEntityProviderTable, this);
            }
            return this._foreignLegalContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "CustomerContainer", {
        get: function () {
            if (this._customerContainer == null) {
                this._customerContainer = new VersionElementContainer(TableCollection.CustomerTable, this);
            }
            return this._customerContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "DeclarerContainer", {
        get: function () {
            if (this._declarerContainer == null) {
                this._declarerContainer = new VersionElementContainer(TableCollection.DeclarerTable, this);
            }
            return this._declarerContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "TofkContainer", {
        get: function () {
            if (this._tofkContainer == null) {
                this._tofkContainer = new VersionElementContainer(TableCollection.TofkTable, this);
            }
            return this._tofkContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "TofkMinfinContainer", {
        get: function () {
            if (this._tofkMinfinContainer == null) {
                this._tofkMinfinContainer = new TofkMinfinContainer(TableCollection.TofkMinfinTable, this);
            }
            return this._tofkMinfinContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "BankShortContainer", {
        get: function () {
            if (this._bankShortContainer == null) {
                this._bankShortContainer = new ElementContainer(TableCollection.BankShortTable, this);
            }
            return this._bankShortContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "LegalEntityShortContainer", {
        get: function () {
            if (this._legalEntityShortContainer == null) {
                this._legalEntityShortContainer = new ElementContainer(TableCollection.LegalEntityProviderShortTable, this);
            }
            return this._legalEntityShortContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "IndividualBusinessmanShortContainer", {
        get: function () {
            if (this._individualBusinessmanShortContainer == null) {
                this._individualBusinessmanShortContainer = new ElementContainer(TableCollection.IndividualBusinessmanShortTable, this);
            }
            return this._individualBusinessmanShortContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "ForeignCitizenShortContainer", {
        get: function () {
            if (this._foreignCitizenShortContainer == null) {
                this._foreignCitizenShortContainer = new ElementContainer(TableCollection.ForeignCitizenShortTable, this);
            }
            return this._foreignCitizenShortContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "ForeignLegalShortContainer", {
        get: function () {
            if (this._foreignLegalShortContainer == null) {
                this._foreignLegalShortContainer = new ElementContainer(TableCollection.ForeignLegalEntityProviderShortTable, this);
            }
            return this._foreignLegalShortContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "CustomerShortContainer", {
        get: function () {
            if (this._customerShortContainer == null) {
                this._customerShortContainer = new ElementContainer(TableCollection.CustomerShortTable, this);
            }
            return this._customerShortContainer;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "InfoEditor", {
        get: function () {
            if (this._infoEditor == null) {
                this._infoEditor = new InfoRegistryElementEditor(this);
            }
            return this._infoEditor;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DocumentFMain.prototype, "RequestEditor", {
        get: function () {
            if (this._requestEditor == null) {
                this._requestEditor = new RequestRegistryElementEditor(this);
            }
            return this._requestEditor;
        },
        enumerable: true,
        configurable: true
    });
    DocumentFMain.prototype.GetCheckDate = function () {
        var result = new Date();
        var tmpDate = this.BankGuaranteesTable.GetMinDate();
        if (tmpDate && +tmpDate < +result) {
            result = tmpDate;
        }
        tmpDate = this.BankGuaranteesRequestTable.GetMinDate();
        if (tmpDate && +tmpDate < +result) {
            result = tmpDate;
        }
        return +result.setDate(result.getDate() - 1);
    };

    Object.defineProperty(DocumentFMain.prototype, "PrintOptionsTable", {
        get: function () {
            if (this._printOptionsTable == null) {
                this._printOptionsTable = new PrintOptionsSprTable(this);
            }
            return this._printOptionsTable;
        },
        enumerable: true,
        configurable: true
    });

    return DocumentFMain;
}(DocumentObject));
